import React from 'react';

import Header from '@/components/Layout/Header';

import VideoJS from '@/components/Layout/VideoJS';
import PlyrJS from '@/components/Layout/PlyrJS';

import SearchBar from '@/components/Layout/SearchBar';
import Results from '@/components/Layout/Results';

import { GalleryData, VideoData } from '@/meta/data';


interface Props {
    id: string
    data: VideoData
    related: GalleryData[]
}

const Video: React.FC<Props> = (props) => {

    const { data, related } = props;

    return (
        <>
            <Header />
            {data.srcSet ? <PlyrJS data={data} /> : <VideoJS data={data} />}
            <SearchBar />
            {related && <Results data={related} />}
        </>
    );
};

export default Video;