import { PORNHUB_BASE_URL, PORNHUB_BASE_URL_VIDEO } from "@/constants/urls";
import { FetchParams, GalleryData, VideoData, VideoSourceItem } from "@/meta/data";
import { getHeaders, getHeadersWithCookie } from "../common/headers";
import { getDataFromRedis, storeDataIntoRedis } from "@/redis/client";
import { DEFAULT_PORNHUB_VIDEO_EXPIRY, DEFAULT_RELATED_VIDEO_KEY_PATH } from "@/constants/redis";

import * as cheerio from "cheerio";

import axios, { AxiosError } from "axios";
import { createSessionCookie, findGetMediaUrlInTagblock } from "../common/mindgeek";
import { getPornHubMediaUrlList } from "./url";

export const fetchPornHubVideoData = async (videoId: string, params?: FetchParams): Promise<[VideoData, GalleryData[]]> => {

    let data: VideoData = {
        lowResUrl: '',
        srcSet: []
    }

    let mediaUrl, sessionCookie, convertedData: VideoSourceItem[]

    let reqHeaders = getHeaders(PORNHUB_BASE_URL)

    const queryUrl = `${PORNHUB_BASE_URL_VIDEO}${videoId.replace(/\//g, '')}`

    const cachedVideoData = await getDataFromRedis(queryUrl)

    if (cachedVideoData) {
        return [cachedVideoData as VideoData, []]
    }

    await axios.get(queryUrl, reqHeaders)

        .then(async response => {

            sessionCookie = response?.headers["set-cookie"] ? createSessionCookie(response?.headers["set-cookie"]) : '';

            const html = response.data;

            const $ = cheerio.load(html);

            const scriptTags = $("script");

            scriptTags.map((idx, elem) => {
                const getMediaUrl = findGetMediaUrlInTagblock($(elem).toString()) ?? null

                if (getMediaUrl) {
                    mediaUrl = getMediaUrl
                }

            })

        }).catch((error: AxiosError) => {
            // error handling goes here
        });

    if (sessionCookie && mediaUrl) {
        convertedData = await getPornHubMediaUrlList(mediaUrl, sessionCookie)
        data.srcSet = convertedData.reverse()

        await storeDataIntoRedis(queryUrl, data, DEFAULT_PORNHUB_VIDEO_EXPIRY);
    }

    return [ data, []]
}